#ifndef FORTUNA_URANDOM_ENTROPY_SRC_H
#define FORTUNA_URANDOM_ENTROPY_SRC_H

#include "entropy_src.h"
#include "event_adder_impl.h"
#include "event_scheduler_impl.h"

#include <fmt/core.h>

#include <cstddef>
#include <cstdint>
#include <fstream>
#include <vector>

namespace fortuna {
namespace accumulator {

class UrandomEntropySrc : public EntropySrc {
private:
	static std::vector<char> bytes;

public:
	auto schedule(accumulator::EventSchedulerImpl scheduler) -> void;

	auto event(accumulator::EventAdderImpl adder) -> void;

	auto urandom_entropy_src_service() -> int;
};

} // namespace accumulator
} // namespace fortuna
#endif // FORTUNA_URANDOM_ENTROPY_SRC_H
